;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)
(provide 'color-specialist)
(require 'lib "epilog:lib;lib")
(require 'spec "epilog:spec;spec")
(defpackage color-specialist (:nicknames color) (:use lisp user spec lib)
  (:export
	  compare-preds 	; main routine for comparing colors
	  color-info 		; print function for display purposes
	  make-color		; routine for adding new colors
	  ))
(unless (find-package 'color) (make-package 'color)))
(in-package color-specialist)

(traceable 'epilog::color-test 
  "Traces comparisons of predicates by the color specialist")
(traceable 'epilog::color-details 
  "Traces details of comparisons of predicates by the color specialist")
(traceable 'epilog::color-all 
  "Traces everything about color comparison"
  '(epilog::color-test epilog::color-details))

(load "epilog:color;compare")
(load "epilog:color;print")

; load the colors themselves
(load "epilog:color;colors")

(defun epilog::make-color (&rest args) (apply 'make-color args))
(defun epiuser::make-color (&rest args) (apply 'make-color args))
(epilog::esh-add-cmds '(make-color))
