;       Last change    August 1993
(in-package epilib)

(tweakable '*check-pred-parts* nil 
 "Indicates if necesary to check existence of first part of compound predicate"
 'boolean)

(defmacro pred-parts (a) `(if (symbolp ,a) (getp ,a 'pred-parts)))

; split predicate into two parts, if possible
; use specialist and indicators of 2nd part
(defun pred-info (pred &optional nocopy &aux 
		       (pparts (split-pred pred nocopy)))
  (if (and nocopy (listp pparts)
	   (not (or (equal (last1 pparts) 'part)
	       (member (last1 pparts) *remainder-indicators*))))
      (return-from pred-info nil))
  (cond ((listp pparts)
	 ; this needs to be done better!!!!
	 (unless nocopy
	 (setp pred 'specialists 
	       (set-difference (getp (cadr pparts) 'specialists)
	         '(time-specialist number-specialist set-specialist) ))
	 (setp pred 'indicators (getp (cadr pparts) 'indicators)) 
	 )
	 (setp pred 'pred-parts pparts)
	 (unless nocopy
	 (print-line "Normalization: Split " pred " into " (car pparts) " and " 
		     (cadr pparts) )
	 (print-line "  - assuming " (print-info pred) 
		     " is similar to " (cadr pparts)) )
	 t)
	(t nil))
  )

(defun split-pred (pred &optional nocopy &aux
                        (plist (unpack pred))
                        pparts initp pp p1 p2)
  (do ((pos (position '- plist) (position '- plist)))
      ((null pos))
      (setq pp (build-symbol (subseq plist 0 pos) 'epilog))
      (setq pparts (append pparts (list pp)))
      (setq plist (subseq plist (+ pos 1)))
      )  
  (setq pparts (append pparts (list (build-symbol plist 'epilog))))
  ; divide up so that all parts are members of a hierarchy
  (if (null (cdr pparts)) (return-from split-pred pred))

  (do ((p (car pparts) (car pparts)))
      ((null p))
      (setq initp (append initp (list p)))
      (setq pparts (cdr pparts))
      (setq p2 (insert- pparts))
      (when (and (not (pred-parts p2))
		 (or nocopy (getp p2 'specialists) (getp p2 'indicators)))
	    (setq p1 (insert- initp))
	    ; necessary to test this?
	    (if (and (not (pred-parts p1))
		     (or nocopy (not *check-pred-parts*) 
			 (getp p1 'specialists) (getp p1 'indicators)))
		(return-from split-pred (list p1 p2)))
	    ))
  pred)


(defun insert- (list &aux retlist)
  (do ((l (car list) (car list)))
      ((null l))
      (setq list (cdr list))
      (setq retlist (append retlist (list l)))
      (when list (setq retlist (append retlist (list '-))))
      )
  (build-symbol retlist 'epilog)
  )
