;       Last change    August 1993
(in-package epilib)
;                  Specialist Interface
;

(traceable 'function-eval "Traces function evaluations")
(traceable 'interested-party "Traces addition to interested party lists")
(traceable 'spec-eval "Traces use of specialsist for evaluation")
(traceable 'spec-entry "Traces entry into specialist domains")
(traceable 'spec-test "Traces comparisons")
(traceable 'spec-assert "Traces assertions made by specialists")
(traceable 'spec-int "Traces specialist interface operations"
	   '(function-eval interested-party spec-eval spec-entry spec-test
			   spec-assert))

(defvar *maximum-effort* 7 "maximum effort level")

(tweakable '*specialist-entry-effort* *maximum-effort* 
  "Effort to use in consistency checking on input" 
  `(integer 0 ,*maximum-effort*))
(tweakable '*specialist-eval-effort* *maximum-effort*
  "Effort to use in evaluation using specialists" 
  `(integer 0 ,*maximum-effort*))
(tweakable '*spec-evaluate* t "Use available specialists to evaluate literals"
  'boolean)
(tweakable '*spec-enter* t "Enter formulas into available specialists rep"
  'boolean)
(tweakable '*spec-assumptions* t "Enter assumptions into available specialists rep"
  'boolean)
(tweakable '*spec-assert* t "Allow specialists to make assertions to epilog"
  'boolean)
(tweakable '*fwd-spec-compare* nil
  "Use specialists to compare literals during forward inference" 'boolean)
(tweakable '*spec-compare-lits* t 
	   "Use available specialists to compare literals" 'boolean)
(tweakable '*spec-compare-preds* t 
	   "Use available specialists to compare predicates" 'boolean)
(tweakable '*spec-eval-fn* t "Use available specialists to evaluate functions"
           'boolean)

(defvar *spec-simplify* nil 
  "Indicates whether specialists should be used to simplify formula - set automatically")
(defvar *fn-simplified* nil "Indicates whether functional term simplified")
(defvar *assertions* nil "List of inferences made by specialists")
