;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'episode-specialist)
(require 'lib "epilog:lib;lib")
(require 'spec "epilog:spec;spec")
(defpackage episode-specialist (:nicknames episode) (:use lisp user spec lib)
  (:export
	  compare-preds
	  ))
(unless (find-package 'episode) (make-package 'episode)))
(in-package episode)

(traceable 'epilog::episode-test "Shows comparisons between episodic predicates")

(defun compare-preds (pred1 pred2 &aux 
			    (res 'unknown)
			    (p1 (pred-type pred1))
			    (p2 (pred-type pred2))
			    )
  (when (and (equal p1 'constant) (equal p2 'constant))
	; Do not allow any operators
  (setq res 
  (cond (
  (case pred1
	(**
	 (case pred2 
	       ((* @) 'subsumed)
	       (** 'equivalent) ))
	(*
	 (case pred2
	       (** 'subsumes)
	       (* 'equivalent)
	       (@ 'subsumed) ))
	(@
	 (case pred2
	       ((** *) 'subsumes)
	       (@ 'equivalent) ))
	))
	(t 'unknown))) 
  (when (and (traced-p 'epilog::episode-test) 
	     (not (equal res 'unknown)))
	(print-line "    Episode-specialist: Compared " (print-info pred1) 
		    " with " (print-info pred2) " - result " res))
	)
  res)
