;       Last change    August 1993
(in-package equal)   

;                         FUNCTIONS
; These functions are functions the user may have in propositions
; When evaluated, they use the global specialist effort level for effort

(defun equivalence-set (&rest args &aux
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (equiv-set-name a1 t))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: EQUIVALENCE-SET "
		               args " evaluated to " (print-info res)))
	  )
  res)

(defun non-equal-set (&rest args &aux
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (non-equal-set-name a1 t))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: NON-EQUAL-SET "
		               args " evaluated to " (print-info res)))
	  )
  res)

(defun equivalence-members (&rest args &aux
		       (usenet (get-subnet nil))
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (get-contents usenet (equiv-set-name a1)))
	  (setq res (remove-if #'+equal res))
	  (unless (null res)
		  (setq res (new-record res 'set)))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: EQUIVALENCE-MEMBERS "
		               args " evaluated to " (print-info res)))
	  )
  res)

(defun equivalence-members-0 (&rest args &aux
		       (usenet (get-subnet nil))
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (get-contents-0 usenet (equiv-set-name a1)))
	  (setq res (remove-if #'+equal res))
	  (unless (null res)
		  (setq res (new-record res 'set)))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: EQUIVALENCE-MEMBERS-0 "
		               args " evaluated to " (print-info res)))
	  )
  res)

(defun non-equal-members (&rest args &aux
		       (usenet (get-subnet nil))
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (get-contents usenet (non-equal-set-name a1)))
	  (setq res (remove-if #'+equal res))
	  (unless (null res)
		  (setq res (new-record res 'set)))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: NON-EQUAL-MEMBERS "
		               args " evaluated to " (print-info res)))
	  )
  res)

(defun non-equal-members-0 (&rest args &aux
		       (usenet (get-subnet nil))
		       (a1 (car args))
		       res)
  (unless (or (null args) (cdr args))
	  (setq res (get-contents-0 usenet (non-equal-set-name a1)))
	  (setq res (remove-if #'+equal res))
	  (unless (null res)
		  (setq res (new-record res 'set)))
	(if (or (traced-p 'epilog::function-eval)
		(traced-p 'epilog::equality-function-eval))
              (print-line "    Equality Specialist: NON-EQUAL-MEMBERS-0 "
		               args " evaluated to " (print-info res)))
	  )
  res)

