;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'part-specialist)
(require 'epilib "epilog:epilib;epilib")
(require 'spec "epilog:spec;spec")
(defpackage part-specialist (:nicknames part) (:use lisp user spec lib epilib)
  (:export
	  ;; Functions for the specialist interface

	  enter evaluate incompatible-lits compatible-lits

	  ;; functions which may be used in propositions

	  ))
(unless (find-package 'part) (make-package 'part)))
(in-package part)


(traceable 'epilog::part-entry "Traces input of part information") 
(traceable 'epilog::part-assert "Traces assertions made by part specialist") 
(traceable 'epilog::part-eval "Traces evaluation of part information") 
(traceable 'epilog::part-function-eval "Traces evaluation of part functions") 
(traceable 'epilog::part-test "Traces comparison of part literals") 
(traceable 'epilog::part-all "Traces everything about parts"
           '(epilog::part-entry epilog::part-eval epilog::part-test 
	     epilog::part-assert epilog::part-function-eval))
(traceable 'epilog::part-min "Traces interesting things about parts"
           '(epilog::part-entry epilog::part-eval epilog::part-test 
	     epilog::part-assert epilog::part-function-eval))

; make sure these are all interned into the part package

(defconstant part-preds
  '(part-of))

(load "epilog:part;defs")
(load "epilog:part;general")
;(load "epilog:part;functions")
(load "epilog:part;eval")
(load "epilog:part;enter")
(load "epilog:part;print")
(load "epilog:part;compare")
