;       Last change    August 1993
(in-package epilog)
 
 ;*****************************************************
 ;*                                                   *
 ;*   U S E R   I N T E R F A C E   R O U T I N E S   *
 ;*                                                   *
 ;*****************************************************

 ;;;
 ;;; The following routines are to retrieve/display
 ;;; knowledge kept in the database.
 ;;;
(defun display-infer (wff-name)
  ;;
  ;; Traces how a particular wff has been inferred by showing
  ;; the wff-names and wffs of its ancestors.
  ;;
  (display-infer-process nil wff-name) )


(defun display-infer-short (wff-name)
  ;;
  ;; Traces how a particular wff has been inferred by showing
  ;; the wff-names of its ancestors.
  ;;
  (display-infer-process t wff-name) )

(set-display-function 'infer 'display-infer-process 
  "Displays the inference path used to obtain a wff")


(defun display-infer-process (brief &rest wff-names)
  (dolist (wff-name wff-names)
  ;;
 (if (getp wff-name 'print)
     (if (getp wff-name 'parents)
         (print-ancestors wff-name 0 t (not brief))
	 (print-wff-type brief wff-name))
     (print-line "%% Error: " wff-name " does not exist **" )) )
 NIL ) ; end of DISPLAY-INFER-PROCESS

(defun print-ancestors (wff-name depth full all &aux parents)
  ;; 
 (indent depth)
 (print-it " | " wff-name)
 (if full
     (print-it ": " (getp wff-name 'PRINT) ))
 (when (and (not all) (> depth 0))
       (return-from print-ancestors))
 (cond ((setq parents (getp wff-name 'PARENTS))
        (mapc #'(lambda (x)
                  (print-ancestors x (1+ depth) full all) )
              parents) )
       (t
        (if (getp wff-name 'INPUT-INDEX)
            (print-it " -- story given" )
            (print-it " -- knowledge" )) ) )
 ) ; end of PRINT-ANCESTORS


(set-display-function 'commands 'print-commands "Displays system commands")

(defun print-commands (&rest args) (declare (ignore args)) (help))

